package simple;

import java.util.Vector;

/**
 *	Formal Semantics of Programming Languages
 *	SS 99
 *	1. Exercise
 *
 *	Class represents a function. Use single linked list structure.
 *
 *	@author Jrgen Hartl, 9756179 / 881
 *	@version 1.0 (JDK 1.1.7)
 */
public class Function extends Domain
{
	/* value of source domain */
	Domain source = null;

	/* value of codomain, source value is mapped to */
	Domain dest = null;

	/* link to the function that was updated to create this function */
	Function oldFunction = null;

	public Domain access(Domain source)
	{
		if (this.source == null) /* original function reached */
		{
			return dest;
		}
		else
		if (source.equalObject(this.source)) /* source value mapping found */
		{
			return dest;
		}
		else /* search for mapping in "old" function */
		{
			return oldFunction.access(source);
		}
	}

	public Function update(Domain source, Domain dest)
	{
		return new Function(source, dest, this);
	}

	public String toString()
	{
		if (source == null)
		{
			return "<default>\t-->\t" + ((dest == null) ? "null" : dest.toString());
		}
		else
		{
			return source.toString() + "\t--->\t" + dest.toString() + "\n" + oldFunction.toString();
		}
	}

	public Function(Domain defaultValue)
	{
		oldFunction = null;
		source = null;
		dest = defaultValue;
	}
	
	protected Function(Domain source, Domain dest, Function oldFunction)
	{
		this.oldFunction = oldFunction;
		this.source = source;
		this.dest = dest;
	}
}