package simple;

/**
 *	Formal Semantics of Programming Languages
 *	SS 99
 *	1. Exercise
 *
 *	Class represents domain Environment.
 *	Domain Environment maps identifiers to denotable-values
 *
 *	@author Jrgen Hartl, 9756179 / 881
 *	@version 1.0 (JDK 1.1.7)
 */
public class Environment extends Domain
{
	Function map = null;

	/* create empty environment */
	public static Environment empty()
	{
		return new Environment(DenotableValue.inErrvalue());
	}
	
	public String toString()
	{
		return "(Environment: Mapping:\n" + map.toString() + ")";
	}
	
	public DenotableValue access(Id id)
	{
		return (DenotableValue)map.access(id);
	}
	
	public Environment update(Id id, DenotableValue dval)
	{
		return new Environment(map.update(id, dval));
	}
	
	protected Environment(Function map)
	{
		this.map = map;
	}
	
	protected Environment(DenotableValue defaultValue)
	{
		map = new Function(defaultValue);
	}
}