package simple;

/**
 *	Formal Semantics of Programming Languages
 *	SS 99
 *	1. Exercise
 *
 *	Class represents domain Location.
 *	Domain Location represents computer store locations.
 *
 *	@author Jrgen Hartl, 9756179 / 881
 *	@version 1.0 (JDK 1.1.7)
 */
public class Location extends Domain
{
	/** Holds first store position */
	static final Location firstPosition = new Location(0);
	
	/** Holds store position */
	long position = 0;

	boolean equalObject(Domain obj)
  {
  	if (obj instanceof Location)
    {
    	return equal((Location)obj).isTrue() != null;
    }
    return false;
  }

	public static Location first()
	{
		return firstPosition;
	}

	public String toString()
	{
		return "(Location: " + position + ")";
	}
	
	public Location next()
	{
		return new Location(position + 1);
	}
	
	public Tr equal(Location l)
	{
		if (position == l.position)
		{
			return Tr.inTrue();
		}
		else
		{
			return Tr.inFalse();
		}
	}

	public Tr lessThan(Location l)
	{
		if (position < l.position)
		{
			return Tr.inTrue();
		}
		else
		{
			return Tr.inFalse();
		}
	}
	
	public Tr lessEqualThan(Location l)
	{
		if (position <= l.position)
		{
			return Tr.inTrue();
		}
		else
		{
			return Tr.inFalse();
		}
	}
	
	public Tr greaterThan(Location l)
	{
		if (position > l.position)
		{
			return Tr.inTrue();
		}
		else
		{
			return Tr.inFalse();
		}
	}
	
	public Tr greaterEqualThan(Location l)
	{
		if (position >= l.position)
		{
			return Tr.inTrue();
		}
		else
		{
			return Tr.inFalse();
		}
	}
	
	public Tr unequal(Location l)
	{
		if (position != l.position)
		{
			return Tr.inTrue();
		}
		else
		{
			return Tr.inFalse();
		}
	}
	
	protected Location(long position)
	{
		this.position = position;
	}
}