package simple;

/**
 *	Formal Semantics of Programming Languages
 *	SS 99
 *	1. Exercise
 *
 *	Class represents domain Num.
 *	Domain Num represents integer numbers.
 *	Not an instance of a class represents the value but the value attribute.
 *
 *	@author Jrgen Hartl, 9756179 / 881
 *	@version 1.0 (JDK 1.1.7)
 */
public class Num extends Domain
{
	static final Num Z = new Num(0);
	
	static final Num O = new Num(1);
	
	/** Holds value of number. */
	long value = 0;

	boolean equalObject(Domain obj)
  {
  	if (obj instanceof Num)
    {
    	return equal((Num)obj).isTrue() != null;
    }
    return false;
  }

	public static Num ZERO()
	{
		return Z;
	}

	public static Num ONE()
	{
		return O;
	}

	public String toString()
	{
		return String.valueOf(value);
	}

	public Num negate()
	{
		return new Num(-value);
	}
	
	public Num plus(Num operand)
	{
		return new Num(value + operand.value);
	}
	
	public Num times(Num operand)
	{
		return new Num(value * operand.value);
	}
	
	public Num minus(Num operand)
	{
		return new Num(value - operand.value);
	}
	
	public Num dividedBy(Num operand)
	{
		return new Num(value / operand.value);
	}
	
	public Num modulo(Num operand)
	{
		return new Num(value % operand.value);
	}
	
	public Tr equal(Num operand)
	{
		if (value == operand.value)
		{
			return Tr.inTrue();
		}
		else
		{
			return Tr.inFalse();
		}
	}

	public Tr lessThan(Num operand)
	{
		if (value < operand.value)
		{
			return Tr.inTrue();
		}
		else
		{
			return Tr.inFalse();
		}
	}
	
	public Tr lessEqualThan(Num operand)
	{
		if (value <= operand.value)
		{
			return Tr.inTrue();
		}
		else
		{
			return Tr.inFalse();
		}
	}
	
	public Tr greaterThan(Num operand)
	{
		if (value > operand.value)
		{
			return Tr.inTrue();
		}
		else
		{
			return Tr.inFalse();
		}
	}
	
	public Tr greaterEqualThan(Num operand)
	{
		if (value >= operand.value)
		{
			return Tr.inTrue();
		}
		else
		{
			return Tr.inFalse();
		}
	}
	
	public Tr unequal(Num operand)
	{
		if (value == operand.value)
		{
			return Tr.inTrue();
		}
		else
		{
			return Tr.inFalse();
		}
	}
	
	public Num(long value)
	{
		this.value = value;
	}
	
	public Num(StorableValue sval)
	{
		this.value = sval.value;
	}
	
	public Num(ConstantValue cval)
	{
		this.value = cval.value;
	}
}