package simple;

/**
 *	Formal Semantics of Programming Languages
 *	SS 99
 *	1. Exercise
 *
 *	Class represents domain Referenceable-value.
 *	Domain Referenceable-value represents values,
 *	that can be denoted by arrays.
 *
 *	@author Jrgen Hartl, 9756179 / 881
 *	@version 1.0 (JDK 1.1.7)
 */
public class ReferenceableValue extends Domain
{
	Domain value = Errvalue.ERRVALUE();
	
	public static ReferenceableValue inLocation(Location l)
	{
		return new ReferenceableValue(l);
	}
	
	public static ReferenceableValue inErrvalue()
	{
		return new ReferenceableValue(Errvalue.ERRVALUE());
	}
	
	public String toString()
	{
		return "(ReferenceableValue: " + value.toString() + ")";
	}
	
	public Location isLocation()
	{
		if (value instanceof Location)
		{
			return (Location)value;
		}
		else
		{
			return null;
		}
	}

	public Errvalue isErrvalue()
	{
		if (value instanceof Errvalue)
		{
			return (Errvalue)value;
		}
		else
		{
			return null;
		}
	}
	
	protected ReferenceableValue(Domain value)
	{
		this.value = value;
	}
}