package simple;

/**
 *	Formal Semantics of Programming Languages
 *	SS 99
 *	1. Exercise
 *
 *	Class represents domain Storeaccess-value = Storable-value + Errvalue.
 *	Domain Storeaccess-value represents values,
 *	that can be results of store accesses:
 *
 *	@author Jrgen Hartl, 9756179 / 881
 *	@version 1.0 (JDK 1.1.7)
 */
public class StoreaccessValue extends Domain
{
	Domain value = Errvalue.ERRVALUE();
	
	public static StoreaccessValue inStorableValue(StorableValue sval)
	{
		return new StoreaccessValue(sval);
	}
	
	public static StoreaccessValue inErrvalue()
	{
		return new StoreaccessValue(Errvalue.ERRVALUE());
	}

	public String toString()
	{
		return "(StoreaccessValue: " + value.toString() + ")";
	}
	
	public StorableValue isStorableValue()
	{
		if (value instanceof StorableValue)
		{
			return (StorableValue)value;
		}
		else
		{
			return null;
		}
	}

	public Errvalue isErrvalue()
	{
		if (value instanceof Errvalue)
		{
			return (Errvalue)value;
		}
		else
		{
			return null;
		}
	}
	
	protected StoreaccessValue(Domain value)
	{
		this.value = value;
	}
}