package simple;

import java.io.*;

/**
 *	Formal Semantics of Programming Languages
 *	SS 99
 *	1. Exercise
 *
 *	Class represents syntax domain Command-Block.
 *	K ::= begin C end
 *
 *	@author Jrgen Hartl, 9756179 / 881
 *	@version 1.0 (JDK 1.1.7)
 */
public class BlockCommand extends Block
{
	Command cmd = null;
	
	public String toString()
	{
		return "(BlockCommand: " + cmd.toString() + ")";
	}

	public void intendPrint(PrintStream out, String intend)
	{
		out.print("\n" + intend + "begin");
		cmd.intendPrint(out, intend + INTENDSTEP);
		out.print("\n" + intend + "end");
	}
	
	Poststore execute(Environment e, Store s)
	{
		return cmd.execute(e, s);
	}
	
	public BlockCommand(Command cmd)
	{
		this.cmd = cmd;
	}
}