package simple;

import java.io.*;

/**
 *	Formal Semantics of Programming Languages
 *	SS 99
 *	1. Exercise
 *
 *	Class represents syntax domain Declaration-Block.
 *	K ::= decl D begin C end
 *
 *	@author Jrgen Hartl, 9756179 / 881
 *	@version 1.0 (JDK 1.1.7)
 */
public class BlockDeclaration extends Block
{
	Declaration decl = null;
	Command cmd = null;
	
	public String toString()
	{
		return "(BlockDeclaration: " + decl.toString() + ", " + cmd.toString() + ")";
	}
	
	public void intendPrint(PrintStream out, String intend)
	{
		out.print("\n" + intend + "decl");
		decl.intendPrint(out, intend + INTENDSTEP);
		out.print("\n" + intend + "begin");
		cmd.intendPrint(out, intend + INTENDSTEP);
		out.print("\n" + intend + "end");
	}
	
	Poststore execute(Environment e, Store s)
	{
		Location l = s.markLocn();
		DeclarationResult declRes = decl.execute(e, s);
		Store s1 = null;
		Store s2 = null;
		Poststore p = null;
		
		if ((s1 = declRes.p.isOk()) != null)
		{
			p = cmd.execute(declRes.e, s1);
		}
		else
		if ((s1 = declRes.p.isErr()) != null)
		{
			p = Poststore.inErr(s1);
		}
		
		if ((s2 = p.isOk()) != null)
		{
			return s2.deallocateLocn(l);
		}
		else
		if ((s2 = p.isErr()) != null)
		{
			return Poststore.inErr(s2);
		}
		return null;
	}
	
	public BlockDeclaration(Declaration decl, Command cmd)
	{
		this.decl = decl;
		this.cmd = cmd;
	}
}