package simple;

import java.io.*;

/**
 *	Formal Semantics of Programming Languages
 *	SS 99
 *	1. Exercise
 *
 *	Class represents domain Equal-boolean-expr.
 *	B ::= E1 = E2
 *
 *	@author Jrgen Hartl, 9756179 / 881
 *	@version 1.0 (JDK 1.1.7)
 */
public class BooleanExprEqual extends BooleanExpr
{
	Expression exp1 = null;
	Expression exp2 = null;

	public String toString()
	{
		return "(BooleanExprEqual: " + exp1.toString() + ", " + exp2.toString() + ")";
	}
	
	public void intendPrint(PrintStream out, String intend)
	{
		out.print("(");
		exp1.intendPrint(out, intend);
		out.print(" = ");
		exp2.intendPrint(out, intend);
		out.print(")");
	}
	
	BooleanExprValue execute(Environment e, Store s)
	{
		ExpressibleValue xval1 = exp1.execute(e, s);
		Num n1 = null;
		Errvalue err = null;
		
		if ((n1 = xval1.isNum()) != null)
		{
			ExpressibleValue xval2 = exp2.execute(e, s);
			Num n2 = null;
			
			if ((n2 = xval2.isNum()) != null)
			{
				return BooleanExprValue.inTr(n1.equal(n2));
			}
			else
			if ((err = xval2.isErrvalue()) != null)
			{
				return BooleanExprValue.inErrvalue();
			}
		}
		else
		if ((err = xval1.isErrvalue()) != null)
		{
			return BooleanExprValue.inErrvalue();
		}
		return null;
	}
	
	public BooleanExprEqual(Expression exp1, Expression exp2)
	{
		this.exp1 = exp1;
		this.exp2 = exp2;
	}
}