package simple;

import java.io.*;

/**
 *	Formal Semantics of Programming Languages
 *	SS 99
 *	1. Exercise
 *
 *	Class represents domain Or-boolean-expr.
 *	B ::= B1 or B2
 *
 *	The implementation of or does not use short-circuit evaluation.
 *	(as example).
 *
 *	@author Jrgen Hartl, 9756179 / 881
 *	@version 1.0 (JDK 1.1.7)
 */
public class BooleanExprOr extends BooleanExpr
{
	BooleanExpr bexp1 = null;
	BooleanExpr bexp2 = null;

	public String toString()
	{
		return "(BooleanExprOr: " + bexp1.toString() + ", " + bexp2.toString() + ")";
	}
	
	public void intendPrint(PrintStream out, String intend)
	{
		out.print("(");
		bexp1.intendPrint(out, intend);
		out.print(" or ");
		bexp2.intendPrint(out, intend);
		out.print(")");
	}
	
	BooleanExprValue execute(Environment e, Store s)
	{
		BooleanExprValue bval1 = bexp1.execute(e, s);
		Tr tr1 = null;
		Errvalue err = null;
		
		if ((tr1 = bval1.isTr()) != null)
		{
			BooleanExprValue bval2 = bexp2.execute(e, s);
			Tr tr2 = null;
			
			if ((tr2 = bval2.isTr()) != null)
			{
				return BooleanExprValue.inTr(tr1.or(tr2));
			}
			else
			if ((err = bval2.isErrvalue()) != null)
			{
				return BooleanExprValue.inErrvalue();
			}
		}
		else
		if ((err = bval1.isErrvalue()) != null)
		{
			return BooleanExprValue.inErrvalue();
		}
		return null;
	}
	
	public BooleanExprOr(BooleanExpr bexp1, BooleanExpr bexp2)
	{
		this.bexp1 = bexp1;
		this.bexp2 = bexp2;
	}
}