package simple;

import java.io.*;

/**
 *	Formal Semantics of Programming Languages
 *	SS 99
 *	1. Exercise
 *
 *	Class represents domain Declaration of Array.
 *	D ::= var I[N]
 *
 *	@author Jrgen Hartl, 9756179 / 881
 *	@version 1.0 (JDK 1.1.7)
 */
public class DeclarationArray extends Declaration
{
	Identifier ident = null;
	Numeral upper = null;

	public String toString()
	{
		return "(DeclarationArray: " + ident.toString() + ", " + upper.toString() + ")";
	}
	
	public void intendPrint(PrintStream out, String intend)
	{
		out.print("\n" + intend + "var ");
		ident.intendPrint(out, intend);
		out.print("[");
		upper.intendPrint(out, intend);
		out.print("]");
	}
	
	DeclarationResult execute(Environment e, Store s)
	{
		Num n = upper.execute();
		Tr tr = n.greaterThan(Num.ZERO());
		
		if (tr.isTrue() != null)
		{
			GetstorageResult res = s.getStorage(Num.ONE(), Array.empty(n));
			Store s1 = null;
			
			if ((s1 = res.p.isOk()) != null)
			{
				return new DeclarationResult(
					e.update(ident.execute(), res.dval), Poststore.inOk(s1));
			}
			else
			if ((s1 = res.p.isErr()) != null)
			{
				return new DeclarationResult(e, Poststore.inErr(s1));
			}
		}
		else
		if (tr.isFalse() != null)
		{
			return new DeclarationResult(e, Poststore.inErr(s));
		}
		return null;
	}
	
	public DeclarationArray(Identifier ident, Numeral upper)
	{
		this.ident = ident;
		this.upper = upper;
	}
}