package simple;

import java.io.*;

/**
 *	Formal Semantics of Programming Languages
 *	SS 99
 *	1. Exercise
 *
 *	Class represents domain Declaration of Scalar.
 *	D ::= var I
 *
 *	@author Jrgen Hartl, 9756179 / 881
 *	@version 1.0 (JDK 1.1.7)
 */
public class DeclarationScalar extends Declaration
{
	Identifier ident = null;

	public String toString()
	{
		return "(DeclarationScalar: " + ident.toString() + ")";
	}
	
	public void intendPrint(PrintStream out, String intend)
	{
		out.print("\n" + intend + "var ");
		ident.intendPrint(out, intend);
	}
	
	DeclarationResult execute(Environment e, Store s)
	{
		AllocateLocnResult res = s.allocateLocn();
		Store s1 = null;
		
		if ((s1 = res.p.isOk()) != null)
		{
			return new DeclarationResult(
				e.update(ident.execute(), DenotableValue.inLocation(res.l)), Poststore.inOk(s1));
		}
		else
		if ((s1 = res.p.isErr()) != null)
		{
			return new DeclarationResult(e, Poststore.inErr(s1));
		}
		return null;
	}
	
	public DeclarationScalar(Identifier ident)
	{
		this.ident = ident;
	}
}