package simple;

import java.io.*;

/**
 *	Formal Semantics of Programming Languages
 *	SS 99
 *	1. Exercise
 *
 *	Class represents syntax domain Negate-Expression.
 *	E ::= -E
 *
 *	@author Jrgen Hartl, 9756179 / 881
 *	@version 1.0 (JDK 1.1.7)
 */
public class ExpressionNegate extends Expression
{
	Expression exp = null;
	
	public String toString()
	{
		return "(ExpressionNegate: " + exp.toString() + ")";
	}
	
	public void intendPrint(PrintStream out, String intend)
	{
		out.print("-");
		exp.intendPrint(out, intend);
	}
	
	ExpressibleValue execute(Environment e, Store s)
	{
		ExpressibleValue xval = exp.execute(e, s);
		Num n = null;
		Errvalue err = null;
		
		if ((n = xval.isNum()) != null)
		{
			return ExpressibleValue.inNum(n.negate());
		}
		else
		if ((err = xval.isErrvalue()) != null)
		{
			return ExpressibleValue.inErrvalue();
		}
		return null;
	}
	
	public ExpressionNegate(Expression exp)
	{
		this.exp = exp;
	}
}